:- module(_,_,[make,functions]).
:- use_module(library('make/system_extra')).
:- use_module(library(lists),[append/3]).
:- use_module(library(terms),[atom_concat/2]).
:- use_module(library(format), [format/2, format/3]).
:- use_module(library(random), [random/3]).
:- use_module('SETTINGS').

newline('----------------------------------------------------------------------------'). 

install <- :-
	newline(NL),
	display(NL), nl,
	display('Installing WebDB'), nl,
	display(NL), nl,
	show_settings,
	display(NL), nl,
	atom_concat(~dbdesc, '/dbserver', DBDSE),
	make_dirpath(DBDSE),
	do(['/bin/cp  db_desc_example/dbserver/* ', DBDSE], nofail),
	make_dirpath(~dbhome),
	atom_concat(~dbdata, '/dbserver', DB),
	make_dirpath(DB),
	make_dirpath(~dbtypes),
	make_dirpath(~dbtemplates),
	make_dirpath(~dbadd),
	do(['/bin/cp html_templates/*.html ', ~dbtemplates], nofail),
	do(['/bin/cp db_types_example/* ', ~dbtypes], nofail),
	atom_concat(~dbhome, '/pictures', Pics),
 	make_dirpath(Pics),
	do(['/bin/cp pictures/* ', Pics], nofail),
 	make_dirpath(~dbadmin),
	atom_concat(~dbadmin, '/graph', Graph),
 	copy_file('utils/graph', Graph),
 	atom_concat(~dbadmin, '/dbserver.log', DBLog),
 	writef("# dbserver log file", DBLog),
 	set_perms(DBLog, ~dbserverlogperms),
	display('Compiling WebDB sources: '), nl, nl,
 	do(['cd src ','; ', ~lpmake, ' exec'],nofail),
	display('Compilation finished'), nl,
	display(NL), nl,
	display('Installing WebDB files: '),nl,nl,
 	do(['cd src ','; ', ~lpmake, ' install'],nofail),
	set_perms(~dbadmin, ~webdirperms),
	set_perms(Graph, ~webexeperms),
	set_perms(~dbadd, ~webdirperms),
	set_perms(DB, ~webdirperms),
	set_perms(DBDSE, ~webdirperms),
	set_perms(~dbtypes, ~webdirperms),
	set_perms(~dbtemplates, ~webdirperms),
	do(['cd ', DBDSE,' ; chmod ug+w *'], nofail),
	set_perms(~atom_concat(~dbhome, '/index.html'), ~frontpageperms),
	set_perms(~atom_concat(~dbadmin,'/maintenance.html'), ~frontpageperms),
	display('WebDB files installed'),nl,
	display(NL), nl,
	display('WebDB installation finished. Enjoy!'), nl,
	display(NL), nl.

maintenance <- :-
	do(['cd src ','; ', ~lpmake, ' maintenance'], nofail).
	
clean <- :-
	delete_files(~ls('*.po|*.itf|tmp*|*~')),
	do(['cd src ','; ', ~lpmake, ' clean'],nofail),
	newline(NL),
	display(NL), nl,
	display('Deleted files *.po, *.itf, tmp*, *~'),nl.

distclean <- [clean] :-
	do(['cd src ','; ', ~lpmake, ' distclean'],nofail).

show_settings :-
	display('Settings specified in SETTINGS.pl: '), nl, nl,
	display('Operating System type: '),
	display(~os), nl,
	display('Ciao compiler: '), 
	display(~ciaoc),nl,
	display('Database server address published in: '),
	display(~dbadd), nl,
	display('WebDB home: '),
	display(~dbhome), nl,
	display('WebDB admin directory: '),
	display(~dbadmin), nl,
	display('WebDB URL: '),
	display(~dburl), nl,
	display('WebDB base directory: '),
	display(~dbdatadesc), nl,
	display('WebDB templates :'),
	display(~dbtemplates), nl,
	display('WebDB database: '),
	display(~dbdata), nl,
	display('WebDB database description: '),
	display(~dbdesc), nl,
	display('WebDB database types: '),
	display(~dbtypes), nl.
	
